﻿/*

	LoadServerStatusCommand
	
	This Command class gets the status of
	a server url passed in.  It passes back a ServerStatusVO.
	If it fails to get a status, it passes back a null instead.
	
	by Jesse R. Warden
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/

*/
import org.osflash.arp.CommandTemplate;

import mx.rpc.ResultEvent;
import mx.rpc.FaultEvent;
import mx.rpc.Responder;

import com.jxl.ddo.model.business.LoadServerStatusDelegate;
import com.jxl.ddo.model.Constants;

class com.jxl.ddo.controller.commands.LoadServerStatusCommand extends CommandTemplate
	implements Responder
{
	
	public static var className:String = "LoadServerStatusCommand";
	
	private var lssd:LoadServerStatusDelegate;
	
	private function executeOperation(p_server:String):Void
	{
		lssd = new LoadServerStatusDelegate(this);
		lssd.getServerStatus(p_server);
	}
	
	public function onResult(result:ResultEvent):Void
	{
		delete lssd;
		resultFunction.call(viewRef, new ResultEvent(result.result));
	}
	
	public function onFault(status:FaultEvent):Void
	{
		delete lssd;
		resultFunction.call(viewRef, new ResultEvent(null));
	}
}