﻿/*

	ServerStatusFactory
	
	When a server is pinged, XML is sent back.
	This Factory takes that XML, parses it into
	a usable ValueObject and returns it for you.
	Used primarely for the Business Delegate.  Parsing
	algorithm is pretty simple and dumb so errors
	could occur.
	
	by Jesse R. Warden
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/

*/

import com.jxl.ddo.model.vo.ServerStatusVO;

class com.jxl.ddo.model.factories.ServerStatusFactory
{
	/*
	<Status>
		<allow_admin_role>Server,CustomerService,Observer,SeniorCustomerService,LeadCustomerService,Test</allow_admin_role>
		<world_full>false</world_full>
		<farmid>21</farmid>
		<world_pvppermission>0</world_pvppermission>
		<name>Riedra</name>
		<loginservers>12.130.63.70:9008;12.130.63.71:9008;</loginservers>
		<deny_billing_role/>
		<deny_admin_role/>
		<allow_billing_role>StormreachLimited,StormreachStandard,StormreachTarget,StormreachGuest,StormreachEUPre</allow_billing_role>
	</Status>
	*/
	public static function getServerStatusFromXML(p_xml:XML):ServerStatusVO
	{
		var xmlNodes_array:Array = p_xml.firstChild.childNodes;
		var ss:ServerStatusVO = new ServerStatusVO();
		ss.adminRoles_array = xmlNodes_array[0].firstChild.split(",");
		ss.isWorldFull = (xmlNodes_array[1].firstChild == "false") ? false : true;
		ss.farmID = parseInt(xmlNodes_array[2].firstChild);
		ss.isPVPEnabled = (xmlNodes_array[3].firstChild == "0") ? false : true;
		ss.name = xmlNodes_array[4].firstChild;
		ss.loginServers_array = xmlNodes_array[5].firstChild.split(";");
		ss.denyBillRoles_array = xmlNodes_array[6].firstChild.split(",");
		ss.denyAdminRoles_array = xmlNodes_array[7].firstChild.split(",");
		ss.allowBillingRoles_array = xmlNodes_array[8].firstChild.split(",");
		return ss;
	}
}
