﻿/*

	ValueObjects
	
	Although the initial release does not utilize
	Flash Remoting, the ValueObjects are registered
	here in case future versions do.  This allows
	strong typing with server-side equivalent classes.
	
	Typically in ARP projects, where you are exchanging
	data with the server, you will make that data into a
	series of ValueObject classes so both the server
	and client are speaking the same language,
	and getting strong typing while doing it.
	
	by Jesse R. Warden
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/

*/

import org.osflash.arp.ValueObjectsTemplate;

import com.jxl.ddo.model.vo.ServerStatusVO;
import com.jxl.ddo.model.vo.ServerConfigVO;
import com.jxl.ddo.model.vo.ConfigVO;

class com.jxl.ddo.model.vo.ValueObjects extends ValueObjectsTemplate
{
	
	public function registerValueObjects()
	{
		registerValueObject("com.jxl.ddo.model.vo.ServerStatusVO", 
							com.jxl.ddo.model.vo.ServerStatusVO);
		
		registerValueObject("com.jxl.ddo.model.vo.ServerConfigVO",
							com.jxl.ddo.model.vo.ServerConfigVO);
		
		registerValueObject("com.jxl.ddo.model.vo.ConfigVO",
							com.jxl.ddo.model.vo.ConfigVO);
	}
}