﻿/*

	FilterUtils
	
	Taken from a larger class, this makes
	it easier to utilize the filters without
	having to know low-level details.  All
	parameters, excluding the first, are optional.
	
	by Jesse R. Warden
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/

*/
import flash.filters.DropShadowFilter;
import flash.filters.BitmapFilter;

class com.jxl.ddo.utils.FilterUtils
{
	public static function addShadow(p_target:Object, 
									 p_distance:Number,
									 p_angle:Number,
									 p_color:Number,
									 p_alpha:Number,
									 p_blurX:Number,
									 p_blurY:Number,
									 p_strength:Number,
									 p_quality:Number,
									 p_inner:Boolean,
									 p_knockout:Boolean,
									 p_hideObject:Boolean):Void
	{

		var shadowFilter : DropShadowFilter = new DropShadowFilter();
		
		shadowFilter.alpha = (p_alpha == null) ? 1 : p_alpha;
		shadowFilter.angle = (p_angle == null) ? 45 : p_angle;
		shadowFilter.blurX = (p_blurX == null) ? 4 : p_blurX;
		shadowFilter.blurY = (p_blurY == null) ? 4 : p_blurY;
		shadowFilter.color = (p_color == null) ? 0x000000 : p_color;
		shadowFilter.distance = (p_distance == null) ? 4 : p_distance;
		shadowFilter.hideObject = (p_hideObject == true) ? true : false;
		shadowFilter.inner = (p_inner == true) ? true : false;
		shadowFilter.knockout = (p_knockout == true) ? true : false;
		shadowFilter.quality = (p_quality == null) ? 3 : p_quality;
		shadowFilter.strength = (p_strength == null) ? 1 : p_strength;
		
		addFilter(p_target, shadowFilter);
	}
	
	public static function addFilter(p_target:Object, p_bf:BitmapFilter):Void
	{
		var currentFilters:Array = [p_bf];
		currentFilters = currentFilters.concat(p_target.filters);
		p_target.filters = currentFilters;
	}
}